VERSION 5.00
Begin VB.UserControl CheckBoxEx 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.CheckBox chk 
      Caption         =   "chk"
      Height          =   615
      Left            =   360
      TabIndex        =   0
      Top             =   660
      Width           =   2535
   End
End
Attribute VB_Name = "CheckBoxEx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
Event ClickFromUser()   ' New event, to detect when USER changes Value.
Event ClickFromCode()   ' New event, to detect when CODE changes Value (doesn't fire if code sets Value but isn't changing it).
Event Click()           ' This is just a passthrough of the standard click event.
'
Event KeyDown(KeyCode As Integer, Shift As Integer)
Event KeyPress(KeyAscii As Integer)
Event KeyUp(KeyCode As Integer, Shift As Integer)
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
Dim mbSettingValueFromCode As Boolean
'

Public Property Get Value() As CheckBoxConstants
    Value = chk.Value
End Property
Public Property Let Value(prop As CheckBoxConstants)
    mbSettingValueFromCode = True
    chk.Value = prop
    mbSettingValueFromCode = False
    PropertyChanged "Value"
End Property

Private Sub chk_Click()
    RaiseEvent Click        ' We just always raise this one.  It'll work as the typical CheckBox does.
    '
    ' And now to differentiate how it was generated.
    If mbSettingValueFromCode Then
        RaiseEvent ClickFromCode
    Else
        RaiseEvent ClickFromUser
    End If
End Sub




Public Property Get Alignment() As AlignmentConstants:      Alignment = chk.Alignment:      End Property
Public Property Get Appearance() As Long:                   Appearance = chk.Appearance:    End Property
Public Property Get BackColor() As OLE_COLOR:               BackColor = chk.BackColor:      End Property
Public Property Get Caption() As String:                    Caption = chk.Caption:          End Property
Public Property Get Enabled() As Boolean:                   Enabled = chk.Enabled:          End Property
Public Property Get Font() As Font:                     Set Font = chk.Font:                End Property
Public Property Get ForeColor() As OLE_COLOR:               ForeColor = chk.ForeColor:      End Property


Public Property Let Alignment(prop As AlignmentConstants):      chk.Alignment = prop:   PropertyChanged "Alignment":    End Property
Public Property Let Appearance(prop As Long):                   chk.Appearance = prop:  PropertyChanged "Appearance":   End Property
Public Property Let BackColor(prop As OLE_COLOR):               chk.BackColor = prop:   PropertyChanged "BackColor":    End Property
Public Property Let Caption(prop As String):                    chk.Caption = prop:     PropertyChanged "Caption":      End Property
Public Property Let Enabled(prop As Boolean):                   chk.Enabled = prop:     PropertyChanged "Enabled":      End Property
Public Property Set Font(prop As Font):                     Set chk.Font = prop:        PropertyChanged "Font":         End Property
Public Property Let ForeColor(prop As OLE_COLOR):               chk.ForeColor = prop:   PropertyChanged "ForeColor":    End Property



Private Sub chk_KeyDown(KeyCode As Integer, Shift As Integer):  RaiseEvent KeyDown(KeyCode, Shift):     End Sub
Private Sub chk_KeyPress(KeyAscii As Integer):                  RaiseEvent KeyPress(KeyAscii):          End Sub
Private Sub chk_KeyUp(KeyCode As Integer, Shift As Integer):    RaiseEvent KeyUp(KeyCode, Shift):       End Sub

Private Sub chk_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single):   RaiseEvent MouseDown(Button, Shift, X, Y):  End Sub
Private Sub chk_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single):   RaiseEvent MouseMove(Button, Shift, X, Y):  End Sub
Private Sub chk_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single):     RaiseEvent MouseUp(Button, Shift, X, Y):    End Sub



Private Sub UserControl_Resize() ' Keep sub-controls the same size as the UserControl.
    chk.Top = 0: chk.Left = 0: chk.Width = Width: chk.Height = Height
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    chk.Alignment = PropBag.ReadProperty("Alignment", vbLeftJustify)
    chk.Appearance = PropBag.ReadProperty("Appearance", 1&)
    chk.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    chk.Caption = PropBag.ReadProperty("Caption", vbNullString)
    chk.Enabled = PropBag.ReadProperty("Enabled", True)
    Set chk.Font = PropBag.ReadProperty("Font", chk.Font)
    chk.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    chk.Value = PropBag.ReadProperty("Value", vbUnchecked)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Alignment", chk.Alignment, vbLeftJustify
    PropBag.WriteProperty "Appearance", chk.Appearance, 1&
    PropBag.WriteProperty "BackColor", chk.BackColor, &H8000000F
    PropBag.WriteProperty "Caption", chk.Caption, vbNullString
    PropBag.WriteProperty "Enabled", chk.Enabled, True
    PropBag.WriteProperty "Font", chk.Font
    PropBag.WriteProperty "ForeColor", chk.ForeColor, &H80000012
    PropBag.WriteProperty "Value", chk.Value, vbUnchecked
End Sub

